#include "iRRAM.h"

void printinterval(const INTERVAL& x){
 rprintf("( ");
 rwrite(inf(x), 20);
 rprintf("  ,  ");
 rwrite(sup(x), 20);
 rprintf(" )\n");
}

void compute(){

	REAL a(1);
	REAL b(2);

	INTERVAL x(a,b);
	INTERVAL y(4,3);
	INTERVAL z;

	rprintf("Copy Constructor: \n");
	z=x;
	printinterval(z);

	rprintf("Additions: \n");
	printinterval(x+y);
	printinterval(x+a);
	printinterval(a+b);

	rprintf("Subtractions: \n");
	printinterval(x-y);
	printinterval(x-a);
	printinterval(a-x);
	printinterval(a-b);
	printinterval(y);
	printinterval(REAL(0)-y);


/*	rprintf("Multiplications: \n");
	printinterval(x*y);
	printinterval(x*(REAL(0)-y));
	printinterval(x*INTERVAL(REAL(-1),REAL(1)));
	printinterval(a*b);
*/
	rprintf("Divisions: \n");
	printinterval(x/y);
	printinterval(x/a);
	printinterval(a/x);
	printinterval(a/b);
	
        rprintf("\n\n");
        rprintf("For the interval  x= \n");
        printinterval(x);
        printf("we have e^x...\n");
        printinterval(exp(x));
        printf("ln(x)...\n");
        printinterval(log(x));
        rprintf("log(e^x)...\n");
        printinterval(log(exp(x)));
        rprintf("and especially x^y, where x=y)...\n");
        printinterval(exp(x*log(x)));
        rprintf("furthermore sin(x)...\n");
        printinterval(sin(x));
        rprintf("and cos(x)...\n");
        printinterval(cos(x));
        rprintf("mag(x)...\n");
        rwrite(mag(x), 20); rprintf("\n");
        rprintf("and mig(x)...\n");
        rwrite(mig(x), 20); rprintf("\n");
        rprintf("and mid(x)...\n");
        rwrite(mid(x), 20); rprintf("\n");

}
