#include "iRRAM.h"

/* Compute iteration by J.M.Muller */

bool print_flag=true;

void jmm_float(int count){

  float a=11.0/2.0, b=61.00/11.0, c;

  for (long i=0;i<count;i++ ) {
  
    if (print_flag) {
      rprintf("%13.10f",a); rprintf(" %d\n",i);
    }
    
    c=111-(1130-3000/a)/b;
    a=b; b=c;   

  }
  rprintf("%13.10f",a); rprintf(" %d\n",count);
}

void jmm_double(int count){

  double a=11.0/2.0, b=61.00/11.0, c;

  for (long i=0;i<count;i++ ) {
  
    if (print_flag) {
      rprintf("%13.10f",a); rprintf(" %d\n",i);
    }
    c=111-(1130-3000/a)/b;
    a=b; b=c;   

  }
  rprintf("%13.10f",a); rprintf(" %d\n",count);
}

void jmm_DYADIC(int count){

  DYADIC a=DYADIC(11)/2, b=DYADIC(61)/11, c;

  for (long i=0;i<count;i++ ) {
  
    if (print_flag) {
      rwrite(a,13); rprintf(" %d\n",i);
    }

    c=111-(1130-3000/a)/b;
    a=b; b=c;   

  }
  rwrite(a,13); rprintf(" %d\n",count);
}


void jmm_RATIONAL(int count){

  RATIONAL a=RATIONAL(11)/2, b=RATIONAL(61)/11, c;

  for (long i=0;i<count;i++ ) {

    if (print_flag) {
      rwrite(REAL(a),18); rprintf(" %d\n",i);
    }

    c=111-(1130-3000/a)/b;
    a=b; b=c;   

  }
  rwrite(REAL(a),18); rprintf(" %d\n",count);
}

void jmm_REAL(int count){

  REAL a= REAL(11)/2, b=REAL(61)/11, c;

  for (long i=0;i<count;i++ ) {

    if (print_flag) {
      rwrite(a,18); rprintf(" %d\n",i);
    }

    c=111-(1130-3000/a)/b;
    a=b; b=c;   

  }
  rwrite(a,18); rprintf(" %d\n",count);
}


void compute(){
  int test,count;
  rprintf("\nJMM-example: c=111-(1130-3000/a)/b\n");
  rprintf("\nHow to compute (1=float, 2=double, 3=DYADIC, 4=RATIONAL, 5=REAL) : ");
  rscanf("%d",&test);
  rprintf("How many values: ");
  rscanf("%d",&count);
  rprintf("Print intermediate values (0/1): ");
  rscanf("%d",&print_flag);
  rprintf("\n");
  switch (test) {
     case 1:;
       jmm_float(count);
     break;
     case 2:;
       jmm_double(count);
     break;
     case 3:;
       {
       long p;
       rprintf("Dyadic precision: ");
       rscanf("%d",&p);
       rprintf("\n");
       DYADIC_precision P(p);
       jmm_DYADIC(count);
       }
     break;
     case 4:;
       jmm_RATIONAL(count);
     break;
     case 5:;
       jmm_REAL(count);
     break;
  }
  rprintf("\n");
};
