#include "stdio.h"
#include "stdlib.h"
#include <math.h>                                                                                           
#include "iRRAM.h"
#include "iRRAM_core.h"

// tests of alternative implemenations for sine and cosine

REAL one_minus_cos_approx (long prec, long wd, const REAL& x){
precision_policy(RELATIVE);
  REAL x2=square(x);
  REAL xpow[wd],xf=power(x2,wd),z;
  xpow[0]=-x2/2;
  z=xpow[0];
  for (long i=1; i<wd; i++) {
     xpow[i]=xpow[i-1]*x2/(-(2*i+1)*(2*i+2));
     z+=xpow[i];
  }
  REAL xp=1,e=z;
  INTEGER f=1;
  long i=1;
  while ( upperbound(xpow[wd-1])+upperbound(xp)> prec || bool(! bound(e,-1)) ) {
    xp*=xf; e=0;
    for (long j=0; j<wd; j++) {
      f=1;
      for (long k=i;k<i+wd;k++) f*=(-(2*k+2)*(2*k+1));
      xpow[j]=xpow[j]/REAL(f);
      i=i+1;
      e+=xpow[j];
    }
    e*=xp;     z+=e;
  }
precision_policy(ABSOLUTE);
  return z;
};

REAL cos_new_2 (long prec,const REAL& x){
  long it;
  long wd;
  if ( prec > -100 ) {it =10; wd= 1;}
  else if ( prec > -400 ) {it =15; wd= 2;}
  else if (prec > -800 ) {it=20; wd =2;}
  else if (prec > -1600 ) {it=24; wd =2;}
  else if (prec > -3200 ) {it=40; wd =3;}
  else if (prec > -6400 ) {it=20; wd =4;}
  else if (prec > -12000 ) {it=60; wd =5;}
  else if (prec > -24000 ) {it=80; wd =8;}
  else if (prec > -48000 ) {it=100; wd =12;}
  else if (prec > -100000 ) {it=120; wd =18;}
  else if (prec > -200000 ) {it=140; wd =26;}
  else {
     it=(long)(log(double(-prec))*8+6);
     wd=long(sqrt(double(-prec)/18));
  }  
  REAL y=x;
  long jt=it;

precision_policy(RELATIVE);
  y=scale(y,-it);

  y=one_minus_cos_approx(prec,wd,y);
precision_policy(RELATIVE);

  for (long i=1;i<=it;i+=1) y=scale(y,2)+scale(square(y),1);
precision_policy(ABSOLUTE);

  return 1+y;
};


REAL cos_new_1 (long prec,const REAL& x){
  if (prec >= 0 ) return 0;
  REAL m=modulo(x,2*pi());
  return cos_new_2(prec,m-2*pi());
};



REAL trig_norm(long& position,const REAL& x){
  REAL m=modulo(x,2*pi());
  long i=round(m*100);
  if ( i <  0 ) {i=i+628;m=m+2*pi();}
  if ( i> 550 ) {
    position=1;
    return m-2*pi(); 
  } else if ( i> 392) {
    position=1;return m-2*pi(); 
  } else if ( i> 235) {
    position=1;return m-2*pi(); 
  } else if ( i> 80) {
    position=1;return m-2*pi();
  } else {
    position=1;return m-2*pi(); 
  }
}

//------------------------------------------------------------------------------------
REAL cos_new_alternative_2 (long prec,const REAL& x){
  long it;
  long wd;
  if ( prec > -100 ) {it =8; wd= 1;}
  else if ( prec > -400 ) {it =16; wd= 2;}
  else if (prec > -800 ) {it=20; wd =2;}
  else if (prec > -1600 ) {it=24; wd =2;}
  else if (prec > -3200 ) {it=40; wd =3;}
  else if (prec > -6400 ) {it=50; wd =3;}
  else if (prec > -12000 ) {it=60; wd =5;}
  else if (prec > -24000 ) {it=80; wd =8;}
  else if (prec > -48000 ) {it=100; wd =12;}
  else if (prec > -100000 ) {it=120; wd =18;}
  else if (prec > -200000 ) {it=140; wd =26;}
  else {
     it=(long)(log(double(-prec))*8+6);
     wd=long(sqrt(double(-prec)/18));
  }  
  REAL y=x;
  long jt=it;

precision_policy(RELATIVE);
  y=scale(y,-it);

  y=one_minus_cos_approx(prec,wd,y)+1;
precision_policy(RELATIVE);

  for (long i=1;i<=it;i+=1) y=scale(square(y),1)-1;
precision_policy(ABSOLUTE);

  return y;
};
REAL cos_new_alternative (long prec,const REAL& x){
  if (prec >= 0 ) return 0;
  REAL m=modulo(x,2*pi());
  return cos_new_alternative_2(prec,m-2*pi());
};
REAL cos_new2 (const REAL& x){ return  limit_lip(cos_new_alternative,0,x);};
//------------------------------------------------------------------------------------
REAL cos_new (const REAL& x){ return  limit_lip(cos_new_1,0,x);};
REAL sin_new (const REAL& x){ return  cos_new(x-pi()/2);};

void sincos_new (REAL& s,REAL& c,const REAL& x){ 
  REAL arg=x;
  s=sin_new(arg);
  c=cos_new(arg);
};


/*
void compute(){


  long deci_places;
  long n;
  rprintf("Desired Decimals: ");  rscanf("%ld",&deci_places);

  do {
    rprintf("\n cos(0.5)=");
    rwrite(cos_new(REAL(0.5)),deci_places+8);
    rprintf("\n cos2(0.5)=");
    rwrite(cos_new2(REAL(0.5)),deci_places+8);
    rprintf("\n sin(0.5)=");
    rwrite(sin_new(REAL(0.5)),deci_places+8);
    rprintf("\n\nAnother try? ");
    rscanf("%ld",&deci_places);
  } while ( deci_places > 0 );
};

*/
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>


double cputime(){
 struct rusage r;
 getrusage (RUSAGE_SELF,&r);
 return r.ru_utime.tv_sec+0.000001*r.ru_utime.tv_usec;
 }




void printval(char* c,int DP, const REAL& y)
{
rprintf(c);
rprintf("\n");
rwrite(y,-10*DP/3,DP+8);
rprintf("\n\n");
}


void printval(char* c,int DP, const DYADIC& y)
{
rprintf(c);
rprintf("\n");
rwrite(y,DP+8);
rprintf("\n\n");
}



void compute(){
DYADIC value[100];

int DP;
rprintf("Length of mantissa: ");
rscanf("%d",&DP);
rprintf("\n");


REAL x=sqrt(REAL(3));
REAL y=sqrt(REAL(5));
REAL PI =pi();
long prec=-10*DP/3;
long min_fkt=1;
long max_fkt=10;

for (long fkt=min_fkt; fkt<=max_fkt; fkt++) {
if (fkt ==1)  value[1]=approx(x*y,prec);
if (fkt ==2)  value[1]=approx(x/y,prec);
if (fkt ==3)  value[1]=approx(sqrt(x),prec);
if (fkt ==4)  value[1]=approx(exp(x),prec);
if (fkt ==5)  value[1]=approx(log(x),prec);
if (fkt ==6)  value[1]=approx(sin(x),prec);
if (fkt ==7)  value[1]=approx(cos(x),prec);
if (fkt ==8)  value[1]=approx(sin_new(x),prec);
if (fkt ==9)  value[1]=approx(cos_new(x),prec);
if (fkt ==10)  value[1]=approx(cos_new2(x),prec);
}

for (long fkt=min_fkt; fkt<=max_fkt; fkt++) {

continous_begin();
double s1=cputime(),s2=s1;
long   count=1;
while (s2-s1 < 1 ) {
if (fkt ==1) for (long i=1; i<=count;i++) value[1]=approx(x*y,prec);
if (fkt ==2) for (long i=1; i<=count;i++) value[1]=approx(x/y,prec);
if (fkt ==3) for (long i=1; i<=count;i++) value[1]=approx(sqrt(x),prec);
if (fkt ==4) for (long i=1; i<=count;i++) value[1]=approx(exp(x),prec);
if (fkt ==5) for (long i=1; i<=count;i++) value[1]=approx(log(x),prec);
if (fkt ==6) for (long i=1; i<=count;i++) value[1]=approx(sin(x),prec);
if (fkt ==7) for (long i=1; i<=count;i++) value[1]=approx(cos(x),prec);
if (fkt ==8) for (long i=1; i<=count;i++) value[1]=approx(sin_new(x),prec);
if (fkt ==9) for (long i=1; i<=count;i++) value[1]=approx(cos_new(x),prec);
if (fkt ==10) for (long i=1; i<=count;i++) value[1]=approx(cos_new2(x),prec);
s2=cputime();
count=2*count;
}
continous_end();
if (fkt ==1) rprintf("x*y     took");
if (fkt ==2) rprintf("x/y     took");
if (fkt ==3) rprintf("sqrt(x) took");
if (fkt ==4) rprintf("exp(x)  took");
if (fkt ==5) rprintf("log(x)  took");
if (fkt ==6) rprintf("sin(x)  took");
if (fkt ==7) rprintf("cos(x)  took");
if (fkt ==8) rprintf("sin_n(x)took");
if (fkt ==9) rprintf("cos_n(x)took");
if (fkt ==10) rprintf("cos_n2(x)took");
rprintf(" %f ms  (%d tries in %f s)\n",1000*(s2-s1)/(count-1),count-1,s2-s1);

}


};

