//#include "gmp.h"
#include "GMP_intrat.h"
#define DEFINITION_Dyadic

#define BLOCKSIZE	8
/* BLOCKSIZE: Number of Integer Components in a single block
   in the linked data structure
*/


#ifdef __cplusplus
extern "C" {
#endif



typedef struct S_1 *BlockZeiger;
typedef struct S_1 {
    mp_limb_t BlockFeld[BLOCKSIZE];
    BlockZeiger BlockNext;
} Block;
typedef struct S_3 {
    BOOLEAN negativ;
    long anzahl;
    long highexponent;
    BlockZeiger Wert;
} *Dyadic;
typedef Dyadic Dyadic_Dyadic;

typedef struct {unsigned long mantissa; long exponent; } LRsizetype;

extern void Dyadic_LRCLEAR (Dyadic_Dyadic *Z);
extern void Dyadic_LRINIT (Dyadic_Dyadic *Z);
extern void Dyadic_LRTOINT (const Dyadic_Dyadic *X, long *I);
extern double Dyadic_LRTOREAL (const Dyadic_Dyadic *X);
extern void Dyadic_LRWRITE (const Dyadic_Dyadic *Z, long F);
extern void Dyadic_LRWRITEF (const Dyadic_Dyadic *Z, long L, long R);
extern void Dyadic_LRWRITEE (const Dyadic_Dyadic *Z, long L);
extern char* Dyadic_LRSWRITEE (const Dyadic_Dyadic *Z, long L);
extern double Dyadic_LRTODOUBLE(const Dyadic_Dyadic *Z);
extern void Dyadic_DOUBLETOLR(double Uebergabewert, Dyadic_Dyadic *Z);
extern void Dyadic_LRADD (const Dyadic_Dyadic *X, const Dyadic_Dyadic *Y, Dyadic_Dyadic *Z, long N);
extern void Dyadic_LRSUB (const Dyadic_Dyadic *X, const Dyadic_Dyadic *Y, Dyadic_Dyadic *Z, long N);
extern void Dyadic_LRMULT (const Dyadic_Dyadic *X, const Dyadic_Dyadic *Y, Dyadic_Dyadic *Z, long N);
extern void Dyadic_LRMULTKARAT (const Dyadic_Dyadic *X, const Dyadic_Dyadic *Y, Dyadic_Dyadic *Z, long N);
extern void Dyadic_LRDIV (const Dyadic_Dyadic *X, const Dyadic_Dyadic *Y, Dyadic_Dyadic *Z, long N);
extern void Dyadic_LRABS (const Dyadic_Dyadic *X, Dyadic_Dyadic *Z);
extern void Dyadic_LRINV (const Dyadic_Dyadic *X, Dyadic_Dyadic *Z, long N);
extern void Dyadic_LRSQUARE (const Dyadic_Dyadic *X, Dyadic_Dyadic *Z, long N);
extern void Dyadic_LRSQRT (const Dyadic_Dyadic *X, Dyadic_Dyadic *Z, long N);
extern void Dyadic_LRNEGATE (Dyadic_Dyadic *X);
extern void Dyadic_LRTRUNC (const Dyadic_Dyadic *X, Dyadic_Dyadic *Z);
extern void Dyadic_LRFRAC (const Dyadic_Dyadic *X, Dyadic_Dyadic *Z);
extern void Dyadic_LRCOPY (const Dyadic_Dyadic *X, Dyadic_Dyadic *Z, long N);
extern void Dyadic_LRDUPLICATE (const Dyadic_Dyadic *X, Dyadic_Dyadic *Z);
extern void Dyadic_LRSHIFT (const Dyadic_Dyadic *X, Dyadic_Dyadic *Z, long I);
extern void Dyadic_LRMULTINT (const Dyadic_Dyadic *X, long Y, Dyadic_Dyadic *Z, long N);
extern void Dyadic_LRDIVINT (const Dyadic_Dyadic *X, long Y, Dyadic_Dyadic *Z, long N);
extern void Dyadic_LRADDINT(const Dyadic_Dyadic *X, long Y, Dyadic_Dyadic *Z, long N);
extern void Dyadic_LRSUBINT(const Dyadic_Dyadic *X, long Y, Dyadic_Dyadic *Z, long N);
extern void Dyadic_LRINTSUB( long X, const Dyadic_Dyadic *Y, Dyadic_Dyadic *Z, long N);
extern void Dyadic_LRINTDIV(long X,const Dyadic_Dyadic *Y, Dyadic_Dyadic *Z, long N);
extern void Dyadic_LRTOgmpint(const Dyadic_Dyadic *r, int_gmp_type i);
extern void Dyadic_gmpintTOLR(int_gmp_type i,Dyadic_Dyadic *r);
extern unsigned long Dyadic_LOG2 (unsigned long N);
extern void Dyadic_LIADD (const Dyadic_Dyadic *X, const Dyadic_Dyadic *Y, Dyadic_Dyadic *Z);
extern void Dyadic_LISUB (const Dyadic_Dyadic *X, const Dyadic_Dyadic *Y, Dyadic_Dyadic *Z);
extern void Dyadic_LIMULT (const Dyadic_Dyadic *X, const Dyadic_Dyadic *Y, Dyadic_Dyadic *Z);
extern void Dyadic_LIMULTKARAT (const Dyadic_Dyadic *X, const Dyadic_Dyadic *Y, Dyadic_Dyadic *Z);
extern void Dyadic_LIDIV (const Dyadic_Dyadic *X, const Dyadic_Dyadic *Y, Dyadic_Dyadic *Q, Dyadic_Dyadic *R);
extern void Dyadic_INTTOLR (long W, Dyadic_Dyadic *Z);
extern void Dyadic_DECTOLR (const unsigned char W[], unsigned long , long DExp, Dyadic_Dyadic *Z);
extern long Dyadic_LRSIGN (const Dyadic_Dyadic *X);
extern long Dyadic_LRSIZE (const Dyadic_Dyadic *X);
extern long Dyadic_LRSIZE (const Dyadic_Dyadic *X);
extern void Dyadic_LRGETSIZE(const Dyadic_Dyadic *X, LRsizetype* s);
extern long Dyadic_LRCOMPARE (const Dyadic_Dyadic *X,const Dyadic_Dyadic *Y);
extern long Dyadic_LRLENGTH (const Dyadic_Dyadic *X);
typedef void (*Dyadic_LRErrorProc) (int);
extern Dyadic_LRErrorProc Dyadic_LRError;
extern void Dyadic_LRErrorHalt (int Error);
extern void Dyadic_LRErrorIgnore (int Error);
extern void Dyadic_LRErrorStatus (int Error);
extern long Dyadic_LRVarCount;
extern long Dyadic_LRSpace (void);
extern long Dyadic_LRmaxSpace (void);
extern void BEGIN_Dyadic(void);

#ifdef __cplusplus
}
#endif
